/** @type {import('eslint').Linter.Config} */
module.exports = {
    root: true,
    extends: [
        'prettier',
        'eslint:recommended',
        'plugin:@typescript-eslint/recommended-type-checked',
        'plugin:@typescript-eslint/strict-type-checked',
        'plugin:@typescript-eslint/stylistic-type-checked',
        'plugin:@eslint-community/eslint-comments/recommended'
    ],
    parser: '@typescript-eslint/parser',
    parserOptions: { project: ['./tsconfig.json'] },
    plugins: ['@typescript-eslint'],
    env: { node: true },
    rules: {
        '@typescript-eslint/restrict-template-expressions': ['error', { allowNumber: true }],
        '@eslint-community/eslint-comments/no-unused-disable': 'error'
    },
    overrides: [
        {
            files: ['*.test.ts'],
            plugins: ['jest'],
            extends: ['plugin:jest/recommended'],
            rules: {
                '@typescript-eslint/no-non-null-assertion': 'off',
                'jest/expect-expect': ['error', { assertFunctionNames: ['*assert*', '*expect*'] }],
            },
        },
    ],
};
