/** @type {import('ts-jest/dist/types').InitialOptionsTsJest} */
module.exports = {
    preset: 'ts-jest',
    transform: {
        '^.+\\.tsx?$': [
            'ts-jest',
            {
                diagnostics: false,
                isolatedModules: true,
            },
        ],
    },
    globalSetup: './test/integration/globalSetup.ts',
    globalTeardown: './test/integration/globalTeardown.ts',
    setupFilesAfterEnv: ['./test/setup.ts'],
    testEnvironment: 'node',
    testMatch: ['**/?(*.)test.ts'],
    reporters: ['default', 'buildkite-test-collector/jest/reporter'], // send results to Buildkite Test Analytics
    testLocationInResults: true, // enable column + line capture for Buildkite Test Analytics
    coverageThreshold: {
        global: {
            statements: 80,
            branches: 85,
            lines: 80,
            functions: 70,
        },
    },
};
