import type { TaskMergedTask } from '../../metrics';
import type { AthenaTaskDataEventTypeResponse } from './AthenaTaskDataEventTypeResponse';

export const convertAthenaTaskDataEventTypeResponseToTaskDataEventType = (
    responseData: AthenaTaskDataEventTypeResponse,
): TaskMergedTask => {
    const taskMergedTaskType: TaskMergedTask = {
        organisationId: Number(responseData.organisation_id),
        identifier: responseData.identifier,
        agentAlias: responseData.agentalias,
        createdAt: responseData.createdat,
        shiftId: responseData.shiftid,
        startTime: responseData.starttime,
        endTime: responseData.endtime,
        taskDefinitionId: responseData.taskdefinitionid,
        taskTypeIdentifier: responseData.tasktypeidentifier,
        updatedAt: responseData.updatedat,
        userEmail: responseData.useremail,
        userId: Number(responseData.userid),
    };

    return taskMergedTaskType;
};
