import type { AthenaQueryMetadata } from '../AthenaQueryMetadataModel';
import * as mongodb from '../../utils/mongodb';
import { config } from '../../config';
import { MongoActualMetricModel } from '@agyletime/performance-utils';
// import { convertDateRangeToMatchFilter } from '@agyletime/wfm-mongo-utils';

export const deleteActualsFromMongo = async ({
    queryMetadata,
    shiftIds,
}: {
    queryMetadata: AthenaQueryMetadata;
    shiftIds: string[];
}): Promise<void> => {
    await mongodb.init(config.db);

    await MongoActualMetricModel.deleteMany({
        organisationId: queryMetadata.organisationId,
        workstreamIdentifier: { $in: shiftIds },
        // ...convertDateRangeToMatchFilter({ fromDate: queryMetadata.fromDate, toDate: queryMetadata.toDate }),
    });
};
