import type { AthenaInteractionEventTypeResponse } from './AthenaInteractionEventTypeResponse';
import type { InteractionEventType } from '../../metrics';

export const convertAthenaInteractionEventTypeResponseToInteractionEventType = (
    responseData: AthenaInteractionEventTypeResponse,
): InteractionEventType => {
    const interactionEventType: InteractionEventType = {
        identifier: responseData.identifier,
        organisationId: responseData.organisation_id,
        workstreamIdentifier: responseData.workstreamidentifier,
        agent: {
            integrationAlias: responseData.agentalias,
            wfmId: responseData.userid,
            teamId: responseData.teamid,
        },
        createdAt: responseData.createdat,
        description: responseData.description,
        endTime: responseData.endtime,
        isAssign: Boolean(responseData.isassign),
        isPrivateComment: Boolean(responseData.isprivatecomment),
        isPublicComment: Boolean(responseData.ispubliccomment),
        isReassign: Boolean(responseData.isreassign),
        isStatusChange: Boolean(responseData.isstatuschange),
        startTime: responseData.starttime,
        type: responseData.type,
        updatedAt: responseData.updatedat,
        workEffortSecs: responseData.workeffortsecs,
        workloadTaskId: responseData.workloadtaskid,
        workstreamDefinitionId: responseData.workstreamdefinitionid,
        workstreamDefinition: {
            id: responseData.workstreamdefinitionid,
            name: responseData.workstreamdefinitionname,
        },
        completionStatus: responseData.completionstatus,
        talkTimeSecs: responseData.talktimesecs,
        consultationTimeSecs: responseData.consultationtimesecs,
        wrapTimeSecs: responseData.wraptimesecs,
        holdTimeSecs: responseData.holdtimesecs,
        outsideBusinessHours: Boolean(responseData.outsidebusinesshours),
        isVoiceMail: Boolean(responseData.isvoicemail),
        ivrTimeSecs: responseData.ivrtimesecs,
        ivrHops: responseData.ivrhops,
        isCallback: Boolean(responseData.iscallback),
        isOverflowed: Boolean(responseData.isoverflowed),
        waitTimeSecs: responseData.waittimesecs,
        isTransfer: Boolean(responseData.istransfer),
    };

    return interactionEventType;
};
