import type { AthenaQueryMetadata } from '../AthenaQueryMetadataModel';
import * as mongodb from '../../utils/mongodb';
import { config } from '../../config';
import { V2MongoInteractionMetricModel } from '@agyletime/performance-utils';

export const deleteV2InteractionsFromMongo = async ({
    queryMetadata,
}: {
    queryMetadata: AthenaQueryMetadata;
}): Promise<void> => {
    await mongodb.init(config.db);

    await V2MongoInteractionMetricModel.deleteMany({
        organisationId: queryMetadata.organisationId,
        timeBucketAsLocal: {
            $gte: queryMetadata.fromDate,
            $lte: queryMetadata.toDate,
        },
    });
};
