import type { WorkstreamMetricsEventType } from '../../metrics';
import type { AthenaWorkstreamMetricsEventTypeResponse } from './AthenaWorkstreamMetricEventTypeResponse';

export const convertAthenaWorkstreamMetricEventTypeResponseToWorkstreamMetricsEventType = (
    response: AthenaWorkstreamMetricsEventTypeResponse,
): WorkstreamMetricsEventType => {
    return {
        abandonedAt: response.abandonedat,
        // createdAt: response.createdat,
        csatOffered: response.csatoffered,
        csatResponse: response.csatresponse,
        csatScore: response.csatscore,
        direction: (response.direction.charAt(0).toUpperCase() + response.direction.slice(1)) as 'Inbound' | 'Outbound',
        firstReplyAgentAlias: {
            integrationAlias: response.firstreplyagentalias,
            wfmId: response.firstreplyuserid,
            teamId: response.firstreplyteamid,
        },
        firstReplyEndTime: response.firstreplyendtime,
        firstReplyHandleTimeSecs: response.firstreplyhandletimesecs,
        firstReplyTeamId: response.firstreplyteamid,
        firstReplyTime: response.firstreplytime,
        firstResolutionHandleTimeSecs: response.firstresolutionhandletimesecs,
        firstResolutionTime: response.firstresolutiontime,
        firstResolutionTimeSecs: response.firstresolutiontimesecs,
        firstResolvedAgentAlias: {
            integrationAlias: response.firstresolvedagentalias,
            wfmId: response.firstresolveduserid,
            teamId: response.firstresolvedteamid,
        },
        firstResolvedTeamId: response.firstresolvedteamid,
        firstResolvedUserId: response.firstresolveduserid,
        // handleTimeBreakdownByUsers: JSON.parse(response.handletimebreakdownbyusers),
        // integration: { integrationId: 0, integrationName: '', qmIntegrationId: '', siteId: '' },
        isAbandoned: Boolean(response.isabandoned),
        lastResolutionHandleTimeSecs: response.lastresolutionhandletimesecs,
        lastResolutionTime: response.lastresolutiontime,
        lastResolvedAgentAlias: {
            integrationAlias: response.lastresolvedagentalias,
            wfmId: response.lastresolveduserid,
            teamId: response.lastresolvedteamid,
        },
        meetingServiceLevel: response.meetingservicelevel,
        organisationId: response.organisationid,
        positiveCsatResponse: response.positivecsatresponse,
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        qualityScores: JSON.parse(response.qualityscores),
        serviceLevelInbound: response.servicelevelinbound,
        startTime: response.starttime,
        totalFirstAnswerInteractions: response.totalfirstanswerinteractions,
        totalHandleTime: response.totalhandletime,
        totalInteractions: response.totalinteractions,
        totalNumberOfSolvedInteractions: response.totalnumberofsolvedinteractions,
        totalPrivateComments: response.totalprivatecomments,
        totalPublicComments: response.totalpubliccomments,
        totalReassigns: response.totalreassigns,
        totalReopens: response.totalreopens,
        totalReplies: response.totalreplies,
        totalResolutionHandleTimeSecs: response.totalhandletime,
        totalTouchTimeSecs: response.totaltouchtimesecs,
        totalTouches: response.totaltouches,
        updatedAt: response.updatedat,
        waitTimeSecs: response.waittimesecs,
        // workstreamDefinition: { id: 0, name: '' },
        workstreamDefinitionId: response.workstreamdefinitionid,
        workstreamIdentifier: response.workstreamidentifier,
    };
};
