import type { AthenaQueryMetadata } from '../AthenaQueryMetadataModel';
import * as mongodb from '../../utils/mongodb';
import { config } from '../../config';
import { MongoWorkstreamMetricModel } from '@agyletime/performance-utils';

export const deleteWorkstreamMetricsFromMongo = async ({
    queryMetadata,
    workstreamIds,
}: {
    queryMetadata: AthenaQueryMetadata;
    workstreamIds: string[];
}): Promise<void> => {
    await mongodb.init(config.db);

    await MongoWorkstreamMetricModel.deleteMany({
        organisationId: queryMetadata.organisationId,
        workstreamIdentifier: { $in: workstreamIds },
    });
};
