import type { DeleteResult } from 'mongodb';
import { config } from '../config';
import type { CustomLabelDeleteParameters } from './CustomLabelApiParameters';
import { MongoMetricsConfigCustomLabelModel } from '@agyletime/performance-utils';
import * as mongodb from '../utils/mongodb';

export const doRemoveCustomLabel = async ({
    organisationId,
    field,
}: CustomLabelDeleteParameters): Promise<DeleteResult> => {
    await mongodb.init(config.db);

    const result: DeleteResult = await MongoMetricsConfigCustomLabelModel.deleteOne({
        $and: [
            {
                organisationId: {
                    $eq: organisationId,
                },
            },
            {
                field: {
                    $eq: field,
                },
            },
        ],
    });

    return result;
};
