import type { UpdateResult } from 'mongodb';
import { config } from '../config';
import type { CustomLabelPatchParameters } from './CustomLabelApiParameters';
import { MongoMetricsConfigCustomLabelModel } from '@agyletime/performance-utils';
import * as mongodb from '../utils/mongodb';

export const doUpsertCustomLabel = async ({
    organisationId,
    field,
    category,
    subCategory,
    label,
}: CustomLabelPatchParameters): Promise<UpdateResult> => {
    await mongodb.init(config.db);

    const filter = { organisationId, field };
    const update = {
        $set: {
            organisationId: organisationId,
            field,
            category,
            subCategory,
            label,
        },
    };
    const options = { upsert: true };

    const result: UpdateResult = await MongoMetricsConfigCustomLabelModel.updateOne(filter, update, options);

    return result;
};
