import type { APIGatewayProxyEvent } from 'aws-lambda/trigger/api-gateway-proxy';
import { BadRequestError } from '../errors';

export function extractParameters(event: APIGatewayProxyEvent): Record<string, string | undefined> {
    const field = decodeURIComponent(event.pathParameters?.['field'] ?? '');
    const category = decodeURIComponent(event.pathParameters?.['category'] ?? '');
    const subCategory = decodeURIComponent(event.pathParameters?.['subCategory'] ?? '');

    if (!field) {
        throw new BadRequestError('Invalid field');
    }
    if (!category) {
        throw new BadRequestError('Invalid category');
    }
    if (!subCategory) {
        throw new BadRequestError('Invalid subCategory');
    }

    return { field, category, subCategory };
}
