import { interactionCreatedHandler as interactionsHandler } from '../interactions/eventHandlers/interactionCreatedHandler';
import { v2InteractionCreatedHandler as v2InteractionsHandler } from '../interactions/eventHandlers/v2InteractionCreatedHandler';
import { interactionCreatedHandler as workloadHandler } from '../workload/eventHandlers/interactionCreatedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { processEvents } from '../utils';
import { eventDebugLogger } from './eventDebugLogger';
import type { InteractionCreatedEvent } from '../interactions';

export const interactionCreatedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<InteractionCreatedEvent>(...args);
    await processEvents([interactionsHandler(...args), workloadHandler(...args), v2InteractionsHandler(...args)]);
};
