import { interactionDeletedHandler as interactionsHandler } from '../interactions/eventHandlers/interactionDeletedHandler';
import { v2InteractionDeletedHandler as v2InteractionsHandler } from '../interactions/eventHandlers/v2InteractionDeletedHandler';
import { interactionDeletedHandler as workloadHandler } from '../workload/eventHandlers/interactionDeletedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { processEvents } from '../utils';
import { eventDebugLogger } from './eventDebugLogger';
import type { InteractionDeletedEvent } from '../interactions';

export const interactionDeletedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<InteractionDeletedEvent>(...args);
    await processEvents([interactionsHandler(...args), workloadHandler(...args), v2InteractionsHandler(...args)]);
};
