import { interactionUpdatedHandler as interactionsHandler } from '../interactions/eventHandlers/interactionUpdatedHandler';
import { v2InteractionUpdatedHandler as v2InteractionsHandler } from '../interactions/eventHandlers/v2InteractionUpdatedHandler';
import { processEvents } from '../utils';
import { interactionUpdatedHandler as workloadHandler } from '../workload/eventHandlers/interactionUpdatedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { eventDebugLogger } from './eventDebugLogger';
import type { InteractionUpdatedEvent } from '../interactions';

export const interactionUpdatedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<InteractionUpdatedEvent>(...args);
    await processEvents([interactionsHandler(...args), workloadHandler(...args), v2InteractionsHandler(...args)]);
};
