import { shiftCreatedHandler as rosteredHandler } from '../rostered/eventHandlers/shiftCreatedHandler';
import { shiftCreatedHandler as workloadHandler } from '../workload/eventHandlers/shiftCreatedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { processEvents } from '../utils';
import { eventDebugLogger } from './eventDebugLogger';
import type { ShiftCreatedEvent } from '../types';

export const shiftCreatedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<ShiftCreatedEvent>(...args);
    await processEvents([rosteredHandler(...args), workloadHandler(...args)]);
};
