import { shiftDeletedHandler as rosteredHandler } from '../rostered/eventHandlers/shiftDeletedHandler';
import { processEvents } from '../utils';
import { shiftDeletedHandler as workloadHandler } from '../workload/eventHandlers/shiftDeletedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { eventDebugLogger } from './eventDebugLogger';
import type { ShiftDeletedEvent } from '../types';

export const shiftDeletedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<ShiftDeletedEvent>(...args);
    await processEvents([rosteredHandler(...args), workloadHandler(...args)]);
};
