import { shiftUpdatedHandler as rosteredHandler } from '../rostered/eventHandlers/shiftUpdatedHandler';
import { shiftUpdatedHandler as workloadHandler } from '../workload/eventHandlers/shiftUpdatedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { processEvents } from '../utils';
import { eventDebugLogger } from './eventDebugLogger';
import type { ShiftUpdatedEvent } from '../types';

export const shiftUpdatedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<ShiftUpdatedEvent>(...args);
    await processEvents([rosteredHandler(...args), workloadHandler(...args)]);
};
