import { taskDataMergedHandler as actualsHandler } from '../actuals/eventHandlers/taskDataMergedHandler';
import { taskDataMergedHandler as workloadHandler } from '../workload/eventHandlers/taskDataMergedHandler';
import type { KinesisStreamEvent } from 'aws-lambda';
import { processEvents } from '../utils';
import { eventDebugLogger } from './eventDebugLogger';
import type { TaskDataMergedEvent } from '../types';

export const taskDataMergedHandler = async (...args: [KinesisStreamEvent]): Promise<void> => {
    await eventDebugLogger<TaskDataMergedEvent>(...args);
    await processEvents([actualsHandler(...args), workloadHandler(...args)]);
};
