export interface InteractionUpdatedEvent {
    data: {
        interactionBefore: InteractionEventType;
        interactionAfter: InteractionEventType;
        updates: [UpdatesType];
        operation: string;
    };
}

export interface InteractionCreatedEvent {
    data: {
        interaction: InteractionEventType;
        operation: string;
    };
}

export interface InteractionDeletedEvent {
    data: {
        interaction: InteractionEventType;
        operation: string;
    };
}

export interface InteractionEventType {
    identifier: string;
    organisationId: number;
    workstreamIdentifier: string;
    integration?: IntegrationType;
    agent?: UserType;
    createdAt: string;
    description?: string;
    endTime?: string;
    isAssign?: boolean;
    isPrivateComment?: boolean;
    isPublicComment?: boolean;
    isReassign?: boolean;
    isStatusChange?: boolean;
    startTime: string;
    statusChangeFrom?: string;
    statusChangeTo?: string;
    type: string;
    sourceTypeIdentifier?: string;
    updatedAt?: string;
    workEffortSecs?: number;
    workloadTaskId: number;
    workstreamDefinitionId?: number;
    workstreamDefinitionName?: string;
    workstreamDefinition?: {
        name: string;
        id: number;
    };
    completionStatus?: string;
    talkTimeSecs?: number;
    consultationTimeSecs?: number;
    wrapTimeSecs?: number;
    holdTimeSecs?: number;
    outsideBusinessHours?: boolean;
    isVoiceMail?: boolean;
    ivrTimeSecs?: number;
    ivrHops?: number;
    isCallback?: boolean;
    isOverflowed?: boolean;
    waitTimeSecs?: number;
    isTransfer?: boolean;
}

interface UpdatesType {
    op: string;
    path: string;
    value: { type: unknown };
}

export interface IntegrationType {
    integrationName: string;
    integrationId: number;
    qmIntegrationId: number;
}

interface UserType {
    integrationAlias: string;
    qmId?: number;
    wfmId?: number;
    emailAddress?: string;
    timezone?: string;
    teamId?: number;
}
