import type { Delete } from '../types';
import type { MongoRosteredMetric } from '@agyletime/performance-utils';

interface ShiftMetricUniqueIdentifier {
    organisationId: number;
    userId: number;
    shiftId: string;
}

export const deleteShiftMetrics = ({
    organisationId,
    userId,
    shiftId,
}: ShiftMetricUniqueIdentifier): Delete<MongoRosteredMetric> => {
    if (!organisationId || !userId || !shiftId) {
        throw new Error('Cannot delete shift metrics without all unique identifier');
    }
    return {
        filter: {
            organisationId,
            shiftId,
            userId,
        },
    };
};
