import { log } from '../../../utils';
import type { OrgDetails } from '../../types';
import { config } from '../../../config';
// async for step function invocation
export const determineBatchGroupDelay = async ({
    orgDetails,
    runImmediately,
}: {
    orgDetails: OrgDetails;
    runImmediately?: boolean;
    // eslint-disable-next-line @typescript-eslint/require-await
}): Promise<number> => {
    log.debug('determineBatchGroupDelay', { orgDetails });
    // We'll go with batches of 4
    const { delayInMinutes, batchGroupSize } = config.stepFunctions;
    return runImmediately ? 0 : (orgDetails.id % batchGroupSize) * delayInMinutes * 60;
};
