export interface WorkstreamMetricUpdatedEvent {
    data: {
        workstreamMetrics: WorkstreamMetricsEventType;
        updates: [UpdatesType];
    };
}

export interface WorkstreamMetricCreatedEvent {
    data: {
        workstreamMetrics: WorkstreamMetricsEventType;
    };
}

export interface WorkstreamMetricDeletedEvent {
    data: {
        workstreamMetrics: WorkstreamMetricsEventType;
    };
}

interface UpdatesType {
    op: string;
    path: string;
    value: { type: unknown };
}

export interface WorkstreamMetricsEventType {
    abandonedAt: Date;
    createdAt?: Date;
    csatOffered: number;
    csatResponse: number;
    csatScore: number;
    direction: 'Inbound' | 'Outbound';
    firstReplyAgentAlias: AgentAlias;
    firstReplyEndTime: Date;
    firstReplyHandleTimeSecs: number;
    firstReplyTeamId: number;
    firstReplyTime: string;
    firstResolutionHandleTimeSecs: number;
    firstResolutionTime: string;
    firstResolutionTimeSecs: number;
    firstResolvedAgentAlias: AgentAlias;
    firstResolvedTeamId: number;
    firstResolvedUserId: number;
    handleTimeBreakdownByUsers?: [
        {
            agentAlias: string;
            firstReplyHandleTimeSecs: number;
            firstResolutionHandleTimeSecs: number;
            totalHandleTimeSecs: number;
            totalResolutionHandleTimeSecs: number;
            userId: number;
        },
    ];
    integration?: {
        integrationId: number;
        integrationName: string;
        qmIntegrationId: string;
        siteId: string;
    };
    isAbandoned: boolean;
    lastResolutionHandleTimeSecs: number;
    meetingServiceLevel: number;
    organisationId: number;
    positiveCsatResponse: number;
    qualityScores: unknown[];
    serviceLevelInbound: number;
    startTime: Date;
    totalFirstAnswerInteractions: number;
    totalHandleTime: number;
    totalInteractions: number;
    totalNumberOfSolvedInteractions: number;
    totalPrivateComments: number;
    totalPublicComments: number;
    totalReassigns: number;
    totalReopens: number;
    totalReplies: number;
    totalResolutionHandleTimeSecs: number;
    totalTouches: number;
    totalTouchTimeSecs: number;
    updatedAt: Date;
    waitTimeSecs: number;
    workstreamDefinitionId: number;
    workstreamDefinition?: {
        name: string;
        id: number;
    };
    workstreamIdentifier: string;
    lastResolutionTime: string;
    lastResolvedAgentAlias: AgentAlias;
}

interface AgentAlias {
    emailAddress?: string;
    integrationAlias: string;
    teamId: number;
    timezone?: string;
    wfmId: number;
}
