import { config } from '../config';
import type { UserCacheType } from '../userCache/UserCacheModel';
import { UserCacheModel } from '../userCache/UserCacheModel';
import { log as logger } from './log';

export const getTimezoneForUser = async ({
    organisationId,
    userId,
}: {
    organisationId: number;
    userId: number;
}): Promise<string> => {
    log({ userId, organisationId });
    const [user]: [result: UserCacheType] = await UserCacheModel.find({ id: userId, organisationId }).lean();
    log({ user, userId, organisationId });
    // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
    return user.timezone || 'UTC';
};

function log(data: Record<string, unknown>): void {
    if (config.agyletime.clusterName === 'gamma') {
        logger.info('getTimezoneForUser', data);
    } else {
        logger.debug('getTimezoneForUser', data);
    }
}
