import { config } from '../config';

export const isOrgEnabled = (organisationId: number): boolean => {
    // Comma separated string of org ids e.g. '9,9009'
    const featureFlagValue: string = config.featureFlags.orgAllowListTPM.toLowerCase();

    if (featureFlagValue === 'all' || featureFlagValue === '*') return true;

    // Will default to none if there is no param
    if (featureFlagValue === 'none') return false;

    const organisationIds: number[] = featureFlagValue.split(',').map((orgId) => Number.parseInt(orgId));

    return organisationIds.includes(organisationId);
};
