import type { InferSchemaType } from 'mongoose';
import mongoose, { Schema } from 'mongoose';

const schema = new Schema(
    {
        organisationId: { type: Number, required: true },
        id: { type: Number, required: true },
        name: { type: String, required: true },
        createdDate: { type: Date },
        lastOccurance: { type: Date },
    },
    {
        collection: 'workstream_definitions',
    },
);

schema.index(
    {
        organisationId: 1,
        id: 1,
        name: 1,
    },
    { unique: true },
);
schema.index({
    organisationId: 1,
    createdDate: 1,
    lastOccurance: 1,
});
export type WorkstreamDefinitionsType = InferSchemaType<typeof schema>;
export const WorkstreamDefinitionsModel = mongoose.model<WorkstreamDefinitionsType>(
    'WorkstreamDefinitionsModel',
    schema,
);
