import * as wfmAwsUtils from '@agyletime/wfm-aws-utils';
import { WorkstreamDefinitionsModel } from '../WorkstreamDefinitionsModel';
import * as mongodb from '../../utils/mongodb';
import { config } from '../../config';

export const triggerWsDefRebuild = async (): Promise<void> => {
    await mongodb.init(config.db);
    // Flush workstream definitions
    await WorkstreamDefinitionsModel.deleteMany({});
    await wfmAwsUtils.invokeStepFunction({
        stateMachineArn: process.env['REBUILD_WS_DEF_CACHE_ARN'] ?? '',
        payload: {},
    });
};
