import {
    doSyncPerformanceViews,
    SyncPerformanceViewsDto,
} from '../../../../lib/metrics/agent/workstream/doSyncPerformanceViews';
import * as Mongo from '../../../../lib/utils/mongodb_native';
import * as ssm from '@agyletime/wfm-aws-utils/lib/getSSMParameters';
import * as dbConnection from '@agyletime/wfm-rds-utils/lib/dbConnection';

const organisationId = 9002;

describe('Synchronise performance views between Mongo & MySQL - doSyncPerformanceViews', () => {
    describe('with no event data', () => {
        let eventData: SyncPerformanceViewsDto['eventData'];

        beforeEach(() => {
            eventData = {};
        });

        it('should fail to setup mongo connection', async () => {
            const mongoDb = jest.spyOn(Mongo, 'createMongoConnection');
            // @ts-expect-error type mismatch
            jest.spyOn(dbConnection, 'connect').mockImplementation(() => Promise.resolve());
            jest.spyOn(dbConnection, 'close').mockImplementation(() => Promise.resolve());

            // @ts-expect-error type mismatch
            jest.spyOn(ssm, 'getSSMParametersById').mockImplementation(() => Promise.resolve({ rds: {} }));
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return, @typescript-eslint/no-explicit-any
            mongoDb.mockImplementation(() => Promise.resolve() as any);
            await expect(
                doSyncPerformanceViews({
                    organisationId,
                    eventData,
                }),
            ).rejects.toThrow('Failed to connect to MongoDB');
        });
    });
});
