import { determineBatchGroupDelay } from '../../../../lib/metrics/rostered/reconciliationHandlers/determineBatchGroupDelay';
import { OrgDetails } from '../../../../lib/metrics/types';

describe('determineBatchGroup', () => {
    it('has a delay of 18 minutes for org id 9', async () => {
        let error, results: number | undefined;
        const orgDetails: OrgDetails = {
            id: 9,
            name: 'Org 9',
        };
        try {
            results = await determineBatchGroupDelay({ orgDetails });
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results).toBe(18 * 60);
    });
    it('has a delay of 20 minutes for org id 10', async () => {
        let error, results: number | undefined;
        const orgDetails: OrgDetails = {
            id: 10,
            name: 'Org 10',
        };
        try {
            results = await determineBatchGroupDelay({ orgDetails });
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results).toBe(20 * 60);
    });
    it('has a delay of 22 minutes for org id 11', async () => {
        let error, results: number | undefined;
        const orgDetails: OrgDetails = {
            id: 11,
            name: 'Org 11',
        };
        try {
            results = await determineBatchGroupDelay({ orgDetails });
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results).toBe(22 * 60);
    });
    it('has a delay of 24 minutes for org id 12', async () => {
        let error, results: number | undefined;
        const orgDetails: OrgDetails = {
            id: 12,
            name: 'Org 12',
        };
        try {
            results = await determineBatchGroupDelay({ orgDetails });
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results).toBe(24 * 60);
    });
    it('has a delay of 0 if runImmediately is true', async () => {
        let error, results: number | undefined;
        const orgDetails: OrgDetails = {
            id: 12,
            name: 'Org 12',
        };
        try {
            results = await determineBatchGroupDelay({ orgDetails, runImmediately: true });
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results).toBe(0);
    });
});
