import { DateRange, SerialisedDateRange, generateDailyIntervalsFromDateRange } from '../../lib/metrics';
import type { ISODateTimeString } from '@agyletime/wfm-types';

describe('generateDailyIntervalsFromDateRange', () => {
    it('generates date range', () => {
        let error,
            results: DateRange[] = [];
        const fromDate: ISODateTimeString = '2023-09-01T05:55:22.316Z';
        const toDate: ISODateTimeString = '2023-09-07T05:55:22.316Z';
        const dateRange: SerialisedDateRange = {
            fromDate,
            toDate,
        };
        try {
            results = generateDailyIntervalsFromDateRange(dateRange);
        } catch (e: unknown) {
            error = e;
        }
        expect(error).toBeUndefined();
        expect(results).toBeDefined();
        expect(results.length).toBe(7);
        expect(results[0]?.fromDate.toISOString()).toBe(fromDate);
        expect(results.length && results[results.length - 1]?.fromDate.toISOString()).toBe(toDate);
    });
});
