import { generateAthenaQuery } from '../../lib/athena/utils';
import { ReconciliationTypes } from '../../lib/athena/types';

describe('generateAthenaQuery', () => {
    it('should expose a function', () => {
        expect(generateAthenaQuery).toBeDefined();
    });

    it('generateAthenaQuery return query for task data when type is ReconciliationTypes.TaskData', () => {
        let testResult, testError;
        try {
            testResult = generateAthenaQuery(
                { organisationId: 1, fromDate: new Date(), toDate: new Date() },
                ReconciliationTypes.TaskData,
            );
        } catch (error: unknown) {
            testError = error;
        }
        expect(testError).toBeUndefined();
        expect(testResult).toContain('mongo_taskdatas');
    });
    it('generateAthenaQuery return query for interactions when type is ReconciliationTypes.Interaction', () => {
        let testResult, testError;
        try {
            testResult = generateAthenaQuery(
                { organisationId: 1, fromDate: new Date(), toDate: new Date() },
                ReconciliationTypes.Interaction,
            );
        } catch (error: unknown) {
            testError = error;
        }
        expect(testError).toBeUndefined();
        expect(testResult).toContain('FROM "mongo_interactions"');
    });
});
