import { doHandleInboundUserEvent } from '../../lib/userCache/doHandleInboundUserEvent';
import { getSSMParameters, extractIdentity, getOrganisationApiParamsById } from '@agyletime/wfm-aws-utils';

// jest mocking on
jest.mock('../../lib/userCache/utils/insertOrUpdateUsers');
jest.mock('../../lib/utils/mongodb');
jest.mock('../../lib/userCache/utils/fetchUserById');

jest.mock('@agyletime/wfm-aws-utils', () => {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    const original = jest.requireActual('@agyletime/wfm-aws-utils');
    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
    return {
        ...original,
        getSSMParameters: jest.fn(),
        extractIdentity: jest.fn(),
        getOrganisationApiParamsById: jest.fn(),
    };
});
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const STUBS: any = {};
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { fetchUserById } = require('../../lib/userCache/utils/fetchUserById');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { insertOrUpdateUsers } = require('../../lib/userCache/utils/insertOrUpdateUsers');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const mongodb = require('../../lib/utils/mongodb');
describe('doHandleInboundUserEvent', () => {
    beforeEach(() => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.fetchUserById = jest.fn().mockResolvedValue({});
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        fetchUserById.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.fetchUserById;
        });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.mongodbInit = jest.fn().mockResolvedValue({});
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        mongodb.init.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.mongodbInit;
        });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.insertOrUpdateUsers = jest.fn().mockResolvedValue({});
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        insertOrUpdateUsers.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.insertOrUpdateUsers;
        });

        (getSSMParameters as jest.Mock).mockImplementation(() => [{ id: 9, api: { foo: 'bar' } }]);
        (extractIdentity as jest.Mock).mockImplementation(() => ({
            organisationId: 9,
            identifier: 'admin@agyletime.com',
        }));
        (getOrganisationApiParamsById as jest.Mock).mockImplementation(() => ({
            org: 'params',
        }));
    });
    afterAll(() => {
        jest.resetAllMocks();
    });
    it('should call the appropriate helper function', async () => {
        // eslint-disable-next-line @typescript-eslint/no-confusing-void-expression
        const result = await doHandleInboundUserEvent('test', 1, { user: { id: 1 } });
        expect(result).toBeUndefined();
    });
});
