import { doHandleUserSync } from '../../lib/userCache/doHandleUserSync';
import { SSMParametersForOrganisation } from '@agyletime/wfm-aws-utils';
// jest mocking on
jest.mock('../../lib/utils/mongodb');
jest.mock('../../lib/userCache/syncUsersToDb');
jest.mock('../../lib/userCache/utils/filterOrgParams');
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const STUBS: any = {};
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { syncUsersToDb } = require('../../lib/userCache/syncUsersToDb');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { filterOrgParams } = require('../../lib/userCache/utils/filterOrgParams');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const mongodb = require('../../lib/utils/mongodb');
describe('doHandleUserSync', () => {
    beforeEach(() => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.syncUsersToDb = jest.fn().mockResolvedValue({});
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        syncUsersToDb.mockResolvedValue(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.syncUsersToDb;
        });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.mongodbInit = jest.fn().mockResolvedValue({});
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        mongodb.init.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.mongodbInit;
        });
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    it('should call the appropriate helper functon', async () => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        filterOrgParams.mockImplementation(() => {
            return [{ id: 1 }];
        });
        // eslint-disable-next-line @typescript-eslint/no-confusing-void-expression
        const result = await doHandleUserSync([{ id: 1 } as SSMParametersForOrganisation], 0);
        expect(result).toBeUndefined();
        expect(syncUsersToDb).toHaveBeenCalledTimes(1);
    });
});

it('should return early if no org params', async () => {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
    filterOrgParams.mockImplementation(() => {
        return [];
    });
    // eslint-disable-next-line @typescript-eslint/no-confusing-void-expression
    const result = await doHandleUserSync([], 0);
    expect(result).toBeUndefined();
});
