import { handleInboundUsersEvent } from '../../../lib/userCache/handlers/handleInboundUsersEvent';
import { KinesisStreamEvent } from 'aws-lambda';

// jest mocking on
jest.mock('../../../lib/userCache/doHandleInboundUserEvent');
jest.mock('@agyletime/wfm-aws-utils');
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const STUBS: any = {};
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { doHandleInboundUserEvent } = require('../../../lib/userCache/doHandleInboundUserEvent');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { decodeKinesisPayload } = require('@agyletime/wfm-aws-utils');
describe('handleInboundUsersEvent', () => {
    beforeEach(() => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.doHandleInboundUserEvent = jest.fn().mockResolvedValue('Completed');
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call
        doHandleInboundUserEvent
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            .mockImplementationOnce(() => {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
                return STUBS.doHandleInboundUserEvent;
            })
            // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
            .mockImplementationOnce(() => {
                // eslint-disable-next-line @typescript-eslint/prefer-promise-reject-errors
                return Promise.reject('Failed');
            });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.decodeKinesisPayload = jest.fn().mockResolvedValue({
            agyletimeorganisationId: 1,
            type: 'test',
            data: {},
            id: 1,
        });
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        decodeKinesisPayload.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.decodeKinesisPayload;
        });
    });
    afterAll(() => {
        jest.resetAllMocks();
    });

    it('should call the appropriate helper function', async () => {
        // eslint-disable-next-line @typescript-eslint/no-confusing-void-expression
        const result = await handleInboundUsersEvent(event);
        expect(result).toEqual(undefined);
    });
});

const event = {
    Records: [{ kinesis: { data: '' } }, { kinesis: { data: '' } }],
} as unknown as KinesisStreamEvent;
