import { handleUserSync } from '../../../lib/userCache/handlers/handleUserSync';
import { getSSMParameters } from '@agyletime/wfm-aws-utils';

// jest mocking on
jest.mock('../../../lib/userCache/doHandleUserSync');

jest.mock('@agyletime/wfm-aws-utils', () => {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
    const original = jest.requireActual('@agyletime/wfm-aws-utils');
    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
    return {
        ...original,
        getSSMParameters: jest.fn(),
    };
});
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const STUBS: any = {};
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires
const { doHandleUserSync } = require('../../../lib/userCache/doHandleUserSync');

describe('handleUserSync', () => {
    beforeEach(() => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.doHandleUserSyncMock = jest.fn().mockResolvedValue('Completed');
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.getSSMParameters = jest.fn().mockResolvedValue([]);
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        doHandleUserSync.mockImplementation(() => {
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-member-access
            return STUBS.doHandleUserSyncMock;
        });
        (getSSMParameters as jest.Mock).mockImplementation(() => [{ id: 9, name: 'dummy org' }]);
    });
    afterAll(() => {
        jest.resetAllMocks();
    });
    it('should call the appropriate helper function', async () => {
        const result = await handleUserSync({});
        expect(result).toEqual('Completed');
    });
});
