import { fetchUserById } from '../../../lib/userCache/utils/fetchUserById';
import { config } from '../../../lib/config';
import { BasicAuthApiClientParams } from '@agyletime/wfm-client/lib/types/agyleTimeClient/agyleTimeClient';

// jest mocking on
jest.mock('@agyletime/wfm-client');
// eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-var-requires,@typescript-eslint/no-unsafe-member-access
const UserApi = require('@agyletime/wfm-client').UserApi;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const STUBS: any = {};
describe('fetchUserByIdApi', () => {
    beforeEach(() => {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        STUBS.getUserMock = jest.fn().mockResolvedValue(stubApiResponse);
        // eslint-disable-next-line @typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access
        UserApi.mockImplementation(() => {
            return {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-member-access
                getUserById: STUBS.getUserMock,
            };
        });
    });
    afterAll(() => {
        jest.resetAllMocks();
    });

    it('should fetch user by id', async () => {
        const userIdToFetch = 9988;
        config.agyletime.api_gateway_base_url = 'https://api-au.alpha.cloud.agyletime.net';
        const user = await fetchUserById(9002, userIdToFetch, {} as BasicAuthApiClientParams);
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
        expect(STUBS.getUserMock.mock.calls[0][0]).toEqual(userIdToFetch);
        expect(user).toEqual(sampleAPiResponseData);
    });
});

const sampleAPiResponseData = {
    _id: '6045b74205845b00081a4860',
    __v: 0,
    createdAt: '2021-03-08T05:33:54.604Z',
    email: 'stub.usr1@agyletime.com',
    firstName: 'STUB',
    id: 9,
    integrations: [],
    lastName: 'Chew',
    leaveConfiguration: {
        defaultLeaveDurations: { repeatPeriodInWeeks: 0, weeks: [] },
        _id: '6237159fdb108f0009797674',
        calendar: { id: '603efce07258cd001968f13c', name: 'Alpha Calendar' },
    },
    organisationId: 9002,
    payRates: [],
    preferences: { preferredDaysOff: [], preferredStartTimes: [], preferredWorkloads: [] },
    roles: [],
    startAt: '2020-02-28T13:00:00.000Z',
    systemRole: { id: 4, name: 'Administrator', category: 'Administrator' },
    tags: [{ text: 'godlike' }, { text: 'beyondgodlike' }],
    team: { id: 1, name: 'Administrator' },
    timezone: 'Australia/Sydney',
    updatedAt: '2023-03-20T05:24:20.485Z',
    endAt: null,
    isActive: true,
    permissions: null,
    userTemplate: {},
    teamName: 'Administrator',
    teamId: 1,
};
const stubApiResponse = {
    data: sampleAPiResponseData,
};
